package org.daml.rdf.jena.common;

import com.hp.hpl.mesa.rdf.jena.common.PropertyImpl;
import com.hp.hpl.mesa.rdf.jena.model.Model;
import com.hp.hpl.mesa.rdf.jena.model.RDFException;
import com.hp.hpl.mesa.rdf.jena.model.Resource;
import com.hp.hpl.mesa.rdf.jena.model.StmtIterator;
import com.hp.hpl.mesa.rdf.jena.model.Property;
import org.daml.rdf.jena.model.DynamicModel;


public class DynamicPropertyImpl extends PropertyImpl
{
    public static boolean DEBUG = false;
    
    public DynamicPropertyImpl(String uri, Model model)
	throws RDFException
    {
	super(uri, model);
	//if (DEBUG) System.out.println("*** CREATING PROPERTY");
    }

    public DynamicPropertyImpl(String namespace, String localName, Model model)
	throws RDFException
    {
	super(namespace, localName, model);
	//if (DEBUG) System.out.println("*** CREATING PROPERTY");
    }

    /**
     * load the page containing this URI if it hasn't been loaded already
     */
    protected void maybeLoad()
	throws RDFException
    {
	//if (DEBUG) System.out.println("*** MaybeLoad PROPERTY");
	if (! ((DynamicModel)getModel()).dynamicLoad())
	    return;

	String uri = getURI();
	int hash = uri.lastIndexOf('#');
	if (hash != (-1))
	    uri = uri.substring(0, hash);
	DynamicModel model = (DynamicModel) getModel(); 
	if (! model.isLoaded(uri))
	    {
		if (DEBUG) System.out.println("dynamically reading " + uri); // XXX
		model.read(uri);
	    }
    }

    public StmtIterator listProperties()
	throws RDFException
    {
	maybeLoad();
	return super.listProperties();
    }

    public StmtIterator listProperties(Property p)
	throws RDFException
    {
	maybeLoad();
	return super.listProperties(p);
    }

    public Resource port(Model m)
	throws RDFException
    {
	//if (DEBUG) System.out.println("*** IN PORT()");
	if (getModel() == m)
	    return this;
	else return new DynamicPropertyImpl(getURI(), m);
    }
}
