package org.daml.rdf.jena.common;

import com.hp.hpl.mesa.rdf.jena.common.ResourceImpl;
import com.hp.hpl.mesa.rdf.jena.model.Model;
import com.hp.hpl.mesa.rdf.jena.model.RDFException;
import com.hp.hpl.mesa.rdf.jena.model.Resource;
import com.hp.hpl.mesa.rdf.jena.model.StmtIterator;
import com.hp.hpl.mesa.rdf.jena.model.Property;
import com.hp.hpl.mesa.rdf.jena.model.AnonId;
import org.daml.rdf.jena.model.DynamicModel;


public class DynamicResourceImpl extends ResourceImpl
{
    public static boolean DEBUG = false;

    public DynamicResourceImpl() 
    {
	super();
    }

    public DynamicResourceImpl(AnonId id) 
    {
	super(id);
    }
            
    public DynamicResourceImpl(AnonId id, Model m) 
    {
	super(id, m);
    }
            
    public DynamicResourceImpl(Model m) 
    {
	super(m);
    }
            
    public DynamicResourceImpl(Resource r, Model m) 
    {
	super(r, m);
    }
            
    public DynamicResourceImpl(java.lang.String uri) 
    {
	super(uri);
    }
            
    public DynamicResourceImpl(java.lang.String uri, Model m) 
    {
	super(uri, m);
    }
            
    public DynamicResourceImpl(java.lang.String nameSpace, java.lang.String localName) 
    {
	super(nameSpace, localName);
    }
            
    public DynamicResourceImpl(java.lang.String nameSpace, java.lang.String localName, Model m)
    {
	super(nameSpace, localName, m);
    }

    /**
     * load the page containing this URI if it hasn't been loaded already
     */
    protected void maybeLoad()
	throws RDFException
    {
	if (! ((DynamicModel)getModel()).dynamicLoad())
	    return;

	String uri = getURI();
	int hash = uri.lastIndexOf('#');
	if (hash != (-1))
	    uri = uri.substring(0, hash);
	DynamicModel model = (DynamicModel) getModel(); 
	if (! model.isLoaded(uri))
	    {
		if (DEBUG) System.out.println("dynamically reading " + uri); // XXX
		model.read(uri);
	    }
    }

    public StmtIterator listProperties()
	throws RDFException
    {
	maybeLoad();
	return super.listProperties();
    }

    public StmtIterator listProperties(Property p)
	throws RDFException
    {
	maybeLoad();
	return super.listProperties(p);
    }

    public Resource port(Model m)
	throws RDFException
    {
	//if (DEBUG) System.out.println("*** IN PORT()");
	if (getModel() == m)
	    return this;
	else return new DynamicResourceImpl(getURI(), m);
    }
}
