
package org.daml.rdf.jena.common;

import org.daml.rdf.jena.model.Source;
import org.daml.rdf.jena.model.DynamicModel;
import com.hp.hpl.mesa.rdf.jena.common.Store;
import com.hp.hpl.mesa.rdf.jena.model.*;
import java.util.Iterator;

/**
 * Interface to a triple store that dynamically loads resources as needed.
 *
 * @author mdean
 * @author drager
 * @version $Id: DynamicStore.java,v 1.1.1.1 2003/03/26 20:35:40 drager Exp $
 */

public interface DynamicStore extends Store
{

    /**
     * Enable or disable dynamic loading.
     * The dynamicStore must have a model in order to enable dynamic loading.
     * @returns the resulting value of dynamicLoad.
     */
    public boolean setDynamicLoad(boolean dynamicp);

    /**
     * Returns true if dynamic loading is enabled.
     */
    public boolean dynamicLoad();

    /**
     * Set the model for this store.
     * The model is used to execute the dynamic loading.
     */
    public void setModel(DynamicModel model);

    /**
     * Return the model for this store.
     */
    public DynamicModel getModel();

}
