package test;

import org.daml.rdf.jena.mem.*;
import org.daml.rdf.jena.common.*;
import org.daml.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.common.*;

import java.util.Vector;

public class Test {

    public static void main (String args[])
	throws Exception
    {
	DynamicSourceModelMem model = new DynamicSourceModelMem();

	// Turn on debug messages so we know if something is loaded
	DynamicResourceImpl.DEBUG = true;
	DynamicPropertyImpl.DEBUG = true;

	String uri = "http://www.daml.org/experiment/ontology/beta/example1";
	if (args.length > 0) uri = args[0];

	model.read(uri);
	System.out.println("Loaded "+uri);
	System.out.println("Size = "+ model.size());
	System.out.println("sources= ");
	printIterator(model.listSources());
	System.out.println("urls= "+ model.getLoadedURLs());

	// Copy statements because it's bad to dynamically load while
	// iterating through the statements.
	StmtIterator si = model.listStatements();
	Vector v = new Vector();
	
	while (si.hasNext()) v.add(si.next());
	StmtIterator si2 = new StmtIteratorImpl(v.iterator(), null);
	
	while (si2.hasNext()) {
	    Statement s = si2.next();
	    Property p = s.getPredicate();
	    System.out.println(p);
	    StmtIterator si3 = p.listProperties();
	}

	System.out.println("Size = "+ model.size());
	System.out.println("sources= ");
	printIterator(model.listSources());
	System.out.println("urls= "+ model.getLoadedURLs());

	model.createResource("http://www.daml.org/test#test1");
	    
    }

    public static void printIterator(java.util.Iterator i) 
    {	
	System.out.println("[");
	while (i.hasNext()) {
	    System.out.println(i.next());
	}
	System.out.println("]");
    }    
}
